%define migtools_ver 40
%define db_version 4.0.14
%define backend gdbm
Summary: The configuration files, libraries, and documentation for OpenLDAP.
Name: openldap
Version: 2.0.25
Release: 1.3.0
License: OpenLDAP
Group: System Environment/Daemons
Source0: ftp://ftp.OpenLDAP.org/pub/OpenLDAP/openldap-release/openldap-%{version}.tgz
Source1: http://www.sleepycat.com/update/%{db_version}/db-%{db_version}.tar.gz
Source2: ldap.init
Source3: ftp://ftp.padl.com/pub/MigrationTools-%{migtools_ver}.tar.gz
Source4: migration-tools.txt
Source5: rfc822-MailMember.schema
Source8: README.upgrading
Source9: README.sendbuf
Source10: http://www.OpenLDAP.org/doc/admin/guide.html
Source11: slapd.acl.conf
Source12: sample_address_book_acl.conf
Source20: address_book_admins.ldif
Source21: address_book_creation.ldif
Source22: address_book_entry.ldif
Source23: initial_database.ldif
Source24: pkcs12_email_cert.ldif
Source25: postfix_aliases.ldif
Source27: postfix_virtual_domains.ldif
Source28: openldap_ldif_readme.txt
Source29: openldap-options
## See end of spec file for a description of each patch
Patch0: openldap-2.0.23-config.patch
Patch1: openldap-2.0.12-redhat.patch
Patch2: openldap-1.2.11-cldap.patch
Patch3: openldap-2.0.3-syslog.patch
Patch6: openldap-2.0.23-sendbuf.patch
Patch7: openldap-2.0.11-ldaprc.patch
Patch8: openldap-2.0.11-debug.patch
Patch9: openldap-2.0.11-libtool.patch
Patch10: openldap-2.0.11-linkage.patch
Patch11: openldap-2.0.25-slapd.conf-changes-gd-2.diff
Patch12: openldap-secpatch.diff
Patch21: MigrationTools-38-instdir.patch
Patch22: MigrationTools-36-mktemp.patch
Patch23: MigrationTools-27-simple.patch
Patch24: MigrationTools-26-suffix.patch
Patch25: MigrationTools-24-schema.patch
Patch26: openldap-2.0.25-SuSE-audit-gd-1.diff
URL: http://www.openldap.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPreReq: gdbm-devel, openssl-devel
BuildPreReq: perl, tcp_wrappers
BuildPreReq: libtool >= 1.4
Requires: mktemp

%description
OpenLDAP is an open source suite of LDAP (Lightweight Directory Access
Protocol) applications and development tools. LDAP is a set of
protocols for accessing directory services (usually phone book style
information, but other information is possible) over the Internet,
similar to the way DNS (Domain Name System) information is propagated
over the Internet. The openldap package contains configuration files,
libraries, and documentation for OpenLDAP.

%package devel
Summary: OpenLDAP development libraries and header files.
Group: Development/Libraries
Requires: openldap = %{version}-%{release}

%description devel
The openldap-devel package includes the development libraries and
header files needed for compiling applications that use LDAP
(Lightweight Directory Access Protocol) internals. LDAP is a set of
protocols for enabling directory services over the Internet. Install
this package only if you plan to develop or will need to compile
customized LDAP clients.

%package servers
Summary: OpenLDAP servers and related files.
Prereq: fileutils, openldap = %{version}-%{release}, openssl, /usr/sbin/useradd, /sbin/chkconfig
Group: System Environment/Daemons

%description servers
OpenLDAP is an open-source suite of LDAP (Lightweight Directory Access
Protocol) applications and development tools. LDAP is a set of
protocols for accessing directory services (usually phone book style
information, but other information is possible) over the Internet,
similar to the way DNS (Domain Name System) information is propagated
over the Internet. This package contains the slapd and slurpd servers,
migration scripts, and related files.

%package clients
Summary: Client programs for OpenLDAP.
Prereq: openldap = %{version}-%{release}
Group: Applications/Internet

%description clients
OpenLDAP is an open-source suite of LDAP (Lightweight Directory Access
Protocol) applications and development tools. LDAP is a set of
protocols for accessing directory services (usually phone book style
information, but other information is possible) over the Internet,
similar to the way DNS (Domain Name System) information is propagated
over the Internet. The openldap-clients package contains the client
programs needed for accessing and modifying OpenLDAP directories.

%prep
%setup -q -a 1 -a 3
%patch0 -p1 -b .config
%patch1 -p1 -b .redhat
%patch2 -p1 -b .cldap
%patch3 -p1 -b .syslog
%patch6 -p1 -b .sendbuf
%patch7 -p1 -b .ldaprc
%patch8 -p1 -b .debug
%patch9 -p1 -b .libtool
%patch10 -p1 -b .linkage
%patch11 -p1
##%patch12 -p0
pushd MigrationTools-%{migtools_ver}
%patch21 -p1 -b .instdir
%patch22 -p1 -b .mktemp
%patch23 -p1 -b .simple
%patch24 -p1 -b .suffix
%patch25 -p2 -b .schema
popd
%patch26 -p1

mkdir build-gdbm
ln -s ../configure build-gdbm
mkdir build-berkeley
ln -s ../configure build-berkeley
mkdir build-clients
ln -s ../configure build-clients

%build
dbdir=`pwd`/db-instroot
%ifarch ia64
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -O0"
%endif
CFLAGS="$CPPFLAGS $RPM_OPT_FLAGS -D_REENTRANT -fPIC"; export CFLAGS
TARGET_PLATFORM=%{_target_platform}
%define _target_platform --target=${TARGET_PLATFORM}
libtoolize --force
build() {
%configure \
        --with-slapd --with-slurpd --without-ldapd \
        --with-threads=posix \
        \
        --enable-local --enable-cldap --disable-rlookups \
        \
        --with-tls \
        \
        --enable-passwd \
        --enable-shell \
        --enable-cleartext \
        --enable-crypt \
        \
        --enable-wrappers \
        --enable-ldbm \
        \
        --disable-ipv6 \
	"$@"
make depend
make
}

# Build Berkeley DB and install it into a temporary area, isolating OpenLDAP
# from any future changes to the system-wide Berkeley DB library.
pushd db-%{db_version}/dist
./configure --with-pic --disable-shared --with-uniquename=_openldap_rhl --prefix=${dbdir}
make
make install
popd

# Build one for tools which use gdbm.
pushd build-gdbm
build --enable-ldbm --with-ldbm-api=gdbm --disable-shared --without-kerberos
popd

# Build one for tools which use db.
pushd build-berkeley
build --enable-ldbm --with-ldbm-api=berkeley --disable-shared --without-kerberos
popd

# Build clients without Kerberos password-checking support.
pushd build-clients
build --enable-ldbm --enable-shared --without-kerberos
popd

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
makeinstall() {

# libtool loves relinking shared libraries
rm -f libraries/*/*.la
make
%makeinstall \
	datadir=$RPM_BUILD_ROOT%{_datadir}/openldap \
	libexecdir=$RPM_BUILD_ROOT%{_sbindir} \
	localstatedir=/%{_var}/run \
	sysconfdir=$RPM_BUILD_ROOT%{_sysconfdir}/openldap $@
}

# Install compatibility binaries.
pushd build-gdbm
makeinstall -C servers/slapd/tools
mv $RPM_BUILD_ROOT%{_sbindir}/slapadd $RPM_BUILD_ROOT%{_sbindir}/slapadd-gdbm
mv $RPM_BUILD_ROOT%{_sbindir}/slapcat $RPM_BUILD_ROOT%{_sbindir}/slapcat-gdbm
popd
if [ %{backend} != gdbm ] ; then
	pushd build-berkeley
	makeinstall -C servers/slapd/tools
	mv $RPM_BUILD_ROOT%{_sbindir}/slapadd $RPM_BUILD_ROOT%{_sbindir}/slapadd-berkeley
	mv $RPM_BUILD_ROOT%{_sbindir}/slapcat $RPM_BUILD_ROOT%{_sbindir}/slapcat-berkeley
	popd
fi

# Install clients and libraries.
pushd build-clients
makeinstall
popd

# Set the right set of slap... tools for the server.
ln -f $RPM_BUILD_ROOT%{_sbindir}/slapadd-%{backend} $RPM_BUILD_ROOT%{_sbindir}/slapadd
ln -f $RPM_BUILD_ROOT%{_sbindir}/slapcat-%{backend} $RPM_BUILD_ROOT%{_sbindir}/slapcat

# Install the padl.com migration tools.
mkdir -p $RPM_BUILD_ROOT%{_datadir}/openldap/migration
install -m 755 MigrationTools-%{migtools_ver}/migrate_* \
	$RPM_BUILD_ROOT%{_datadir}/openldap/migration
install -m 644 MigrationTools-%{migtools_ver}/README %{SOURCE4} \
	$RPM_BUILD_ROOT%{_datadir}/openldap/migration
cp MigrationTools-%{migtools_ver}/README README.migration
cp %{SOURCE4} TOOLS.migration

# try to build saucer, but don't fret if we can't
if make -C contrib/saucer ; then
	./libtool install -m755 contrib/saucer/saucer $RPM_BUILD_ROOT%{_bindir}/
	./libtool install -m644 contrib/saucer/saucer.1 $RPM_BUILD_ROOT%{_mandir}/man1/
fi

# Create the data directory.
mkdir -p $RPM_BUILD_ROOT/var/lib/ldap

# Create the addressbook ACL directory
mkdir -p $RPM_BUILD_ROOT/etc/openldap/address_book_acl
install -m 640 %{SOURCE12} $RPM_BUILD_ROOT/etc/openldap/address_book_acl
install -m 640 %{SOURCE11} $RPM_BUILD_ROOT/etc/openldap

# Create template directory
mkdir -p $RPM_BUILD_ROOT/etc/openldap/ldif_templates
install -m 640 %{SOURCE20} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE24} \
               %{SOURCE25} %{SOURCE27} $RPM_BUILD_ROOT/etc/openldap/ldif_templates
install -m 640 %{SOURCE28} $RPM_BUILD_ROOT/etc/openldap/ldif_templates/README.TXT

# Hack the build root out of the default config files.
perl -pi -e "s|$RPM_BUILD_ROOT||g" $RPM_BUILD_ROOT/etc/openldap/slapd.conf

# Get the buildroot out of the man pages.
perl -pi -e "s|$RPM_BUILD_ROOT||g" $RPM_BUILD_ROOT%{_mandir}/*/*.*

# We don't need the default files -- RPM handles changes.
rm -f $RPM_BUILD_ROOT/etc/openldap/*.default

# Install an init script for the server.
mkdir -p $RPM_BUILD_ROOT/etc/init.d
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/init.d/ldap

# Install the options
install -m 755 %{SOURCE29} $RPM_BUILD_ROOT/etc/openldap/ldap_options

# If ldapadd and ldapmodify are the same binary, make them a hard link
if cmp $RPM_BUILD_ROOT%{_bindir}/ldapadd $RPM_BUILD_ROOT%{_bindir}/ldapmodify ; then
	ln -f $RPM_BUILD_ROOT%{_bindir}/ldapadd $RPM_BUILD_ROOT%{_bindir}/ldapmodify
fi

# Add some more schema for the sake of migration scripts.
## install -d -m755 $RPM_BUILD_ROOT%{_sysconfdir}/openldap/schema/redhat
## install -m644 %{SOURCE5} %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/openldap/schema/redhat/

# Tweak permissions on the libraries to make sure they're correct.
chmod +rx $RPM_BUILD_ROOT/%{_libdir}/lib*.so*
chmod +r $RPM_BUILD_ROOT/%{_libdir}/lib*.*a
chmod -x $RPM_BUILD_ROOT/%{_libdir}/lib*.*a

%clean 
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%pre servers
# Take care to only do ownership-changing if we're adding the user.
# Add tcpd group and LDAP to that group
if /usr/sbin/groupadd -f -g 71 tcpd; then
  /bin/chown root.tcpd /etc/hosts.allow /etc/hosts.deny
  /bin/chmod 640 /etc/hosts.allow /etc/hosts.deny
fi

if [ -n "`grep ldap /etc/passwd`" ]; then
  /usr/sbin/userdel -f ldap
fi

if /usr/sbin/useradd -c "LDAP User" -u 55 -G tcpd \
	-s /bin/false -r -d /var/lib/ldap ldap 2> /dev/null ; then
	if [ -d /var/lib/ldap ] ; then
		for dbfile in /var/lib/ldap/* ; do
			if [ -f $dbfile ] ; then
				chown ldap.ldap $dbfile
			fi
		done
	fi
fi


%post servers
/sbin/chkconfig --add ldap

# create default certificate
if [ ! -f %{_datadir}/ssl/certs/slapd.pem ] ; then
pushd %{_datadir}/ssl/certs
umask 077
cat << EOF | make slapd.pem
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
localhost.localdomain
root@localhost.localdomain
EOF
chown root.ldap slapd.pem
chmod 640 slapd.pem
popd
fi
exit 0

%preun servers
if [ "$1" = "0" ] ; then
        /etc/init.d/ldap stop > /dev/null 2>&1 /dev/null
	/sbin/chkconfig --del ldap
fi

%postun servers
/sbin/ldconfig
if [ $1 -ge 1 ] ; then
        /etc/init.d/ldap restart > /dev/null 2>&1 /dev/null
fi

/usr/sbin/userdel ldap

%files
%defattr(-,root,root)
%doc ANNOUNCEMENT CHANGES COPYRIGHT LICENSE README doc/rfc
%attr(0755,root,root) %dir /etc/openldap
%attr(0644,root,root) %config(noreplace) /etc/openldap/ldap*.conf
%attr(0755,root,root) %{_libdir}/lib*.so.*
%attr(0644,root,root) %{_mandir}/man5/*
%attr(0755,root,root) %dir %{_datadir}/openldap
%attr(0644,root,root) %{_datadir}/openldap/ldapfriendly
%attr(0644,root,root) %config(noreplace) /etc/openldap/slapd.acl.conf
%attr(0755,root,root) %dir /etc/openldap/address_book_acl
%attr(0644,root,root) %config(noreplace) /etc/openldap/address_book_acl/*

%files servers
%defattr(-,root,root)
%doc README.migration TOOLS.migration
%doc $RPM_SOURCE_DIR/README.upgrading $RPM_SOURCE_DIR/README.sendbuf $RPM_SOURCE_DIR/guide.html
%attr(0755,root,root) %config /etc/init.d/ldap
%attr(0640,root,ldap) %config(noreplace) /etc/openldap/slapd.conf
%attr(0755,root,root) %dir /etc/openldap/schema
%attr(0644,root,root) %config(noreplace) /etc/openldap/schema/*.schema*
%attr(0755,root,root) %{_sbindir}/*
%attr(0644,root,root) %{_mandir}/man8/*
%attr(0644,root,root) %{_datadir}/openldap/*.help
%attr(0755,root,root) %dir %{_datadir}/openldap/migration
%attr(0644,root,root) %{_datadir}/openldap/migration/README
%attr(0644,root,root) %config(noreplace) %{_datadir}/openldap/migration/*.ph
%attr(0755,root,root) %{_datadir}/openldap/migration/*.pl
%attr(0755,root,root) %{_datadir}/openldap/migration/*.sh
%attr(0644,root,root) %{_datadir}/openldap/migration/*.txt
%attr(0700,ldap,ldap) %dir /var/lib/ldap

%files clients
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/*
%attr(0644,root,root) %{_mandir}/man1/*

%files devel
%defattr(-,root,root)
%doc doc/drafts
%attr(0755,root,root) %{_libdir}/lib*.so
%attr(0644,root,root) %{_libdir}/lib*.a
%attr(0644,root,root) %{_includedir}/*
%attr(0644,root,root) %{_mandir}/man3/*

%changelog
* Thu Apr 10 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.3.0
  - Initial build for EnGarde Secure Community 2 (Feint).

* Mon Feb 24 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.5.0
  - Initial build for EnGarde v1.5 (Thrust).

* Tue Jan 27 2003 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.25, Release 1.2.13
  - Fixed broken chkconfig line in init.d start/stop script
  - Cleaned up some inconsistencies in spec file
  - Removed transport maps from initial db, templtes and ACLs

* Mon Jan 27 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.0.25, Release 1.2.12
  - Update slapd.conf with changes for WebTool (Patch #11).

* Mon Jan 20 2003 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.25, Release 1.2.11
  - Additionaly configuration file changes for better 
    compatibility with the WebTool

* Mon Jan 06 2003 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.25, Release 1.2.10
  - Minor changes to LDIF initial database and ACL lists

* Thu Dec 19 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.0.25, Release 1.2.9
  - Bring in patch from SuSE Security audit (#26).

* Fri Dec 13 2002 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.25, Release 1.2.8
   - Fixed init.d chkconfig issues

* Tue Dec 10 2002 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.25, Release 1.2.7
   - Minor changes in ACL file
   - Fixed init.d script problems
   - Added new tcpd group which LDAP is part of for hosts.deny/allow

* Tue Jul 09 2002 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.25, Release 1.2.6
   - Patched configuration file
   - Added ACL files
   - Added Template files
   - Moved all rc.d files to init.d

* Wed Jun 19 2002 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.25, Release 1.2.5
   - Removed make requirements for openldap-servers
   - Upgraded to version 2.0.25

* Mon Jun 17 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.0.23, Release 1.2.4
  - Disable IPv6.

* Wed Apr 17 2002 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.23, Release 1.2.3
  - Customized config patch for EnGarde
  - Added uninit-var patch to fix password variable issue

* Thu Apr 11 2002 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.23 rel 1.2.2
  - Tweaking for distribution with EnGarde
  - Removed RedHat Schema files

* Tue Mar 26 2002 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.23 rel 1.2.1
  - Removed additional SASL and Kerberos stuff
  - Removed Pam-devel and libtool >= 1.4 build requirements

* Mon Mar 25 2002 Nicholas DeClario <nick@guardiandigital.com>
- Version 2.0.23 rel 1.2.0
  - Removed Cyrus SASL



##############################################################
#
# Description of patch files 
#
##############################################################
#
#  openldap-2.0.25-SuSE-audit-gd-1.diff
#       A security audit done by SuSE to address security related issues
#
#  openldap-2.0.16-config.patch
#	Modifies ldap config files - Updated 
#
#  openldap-2.0.12-redhat.patch
# 	Helps prevent some buffer overflows
#
#  openldap-1.2.11-cldap.patch
# 	Add's '#include <sys/socket.h>' to slap.h
#
#  openldap-2.0.3-syslog.patch
# 	Redirects logs through the system logging daemon
#
#  openldap-2.0.23-sendbuf.patch
#	Sets or determinds send buffer size.  Only becomes enabled
#       if 'SO_SNDBUF' is defined
#
#  openldap-2.0.11-ldaprc.patch
#	A call to check the syntax of a file was always being ran. 
# 	This was changed to only run if certain conditions were met.
#
#  openldap-2.0.11-debug.patch
#	This also lends a hand in preventing buffer overflows
#
#  openldap-2.0.11-libtool.patch
#	Changes 'LDAP_LIBPATH' in '~/build/top.mk' to work with ESL
#
#  openldap-2.0.11-linkage.patch
#	Adds additional dependencies to '~/build/lib-shared.mk'
#
#  openldap-2.0.23-uninit-var.patch
#	Fixes an unitialized variable in the password code
#
#  MigrationTools-38-instdir.patch
#	Sets up migration files in Makefiles so they are properly installed
#
#  MigrationTools-36-mktemp.patch
# 	Replaces '$TMPFILE' with mktemp for all temp files
#
#  MigrationTools-27-simple.patch
#	Modifies migration scripts to allow users to pass arguments through
#	the scripts to ldapadd and ldapmodify
#
#  MigrationTools-26-suffix.patch
#	Automagically fills in missing arguments if not given by the user
#  
#  MigrationTools-24-schema.patch
# 	Supplies dummy, but necessary descriptions in LDIF
#
##############################################################
